/*
  For more information, please see: http://software.sci.utah.edu
  
  The MIT License

  Copyright (c) 2009 Scientific Computing and Imaging Institute,
  University of Utah.


  Permission is hereby granted, free of charge, to any person obtaining a 
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation 
  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
  and/or sell copies of the Software, and to permit persons to whom the 
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included 
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
  DEALINGS IN THE SOFTWARE.
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        brushpanel.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     10/08/2007 11:53:59
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 10/08/2007 11:53:59

#ifndef _BRUSHPANEL_H_
#define _BRUSHPANEL_H_

/*!
 * Includes
 */

// BJW - had to add this manually
#include <wx/wx.h>

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/spinctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_BRUSHPANEL 10000
#define SYMBOL_BRUSHPANEL_STYLE 0
#define SYMBOL_BRUSHPANEL_TITLE _("BrushPanel")
#define SYMBOL_BRUSHPANEL_IDNAME ID_BRUSHPANEL
#define SYMBOL_BRUSHPANEL_SIZE wxSize(200, -1)
#define SYMBOL_BRUSHPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * BrushPanel class declaration
 */

class BrushPanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( BrushPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    BrushPanel();
    BrushPanel( wxWindow* parent, wxWindowID id = SYMBOL_BRUSHPANEL_IDNAME, const wxPoint& pos = SYMBOL_BRUSHPANEL_POSITION, const wxSize& size = SYMBOL_BRUSHPANEL_SIZE, long style = SYMBOL_BRUSHPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_BRUSHPANEL_IDNAME, const wxPoint& pos = SYMBOL_BRUSHPANEL_POSITION, const wxSize& size = SYMBOL_BRUSHPANEL_SIZE, long style = SYMBOL_BRUSHPANEL_STYLE );

    /// Destructor
    ~BrushPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin BrushPanel event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for CLOSE_BUTTON
    void OnCloseButtonClick( wxCommandEvent& event );

////@end BrushPanel event handler declarations

    void OnFloodFillButtonClick( wxCommandEvent& event );
    void OnFloodEraseButtonClick( wxCommandEvent& event );

////@begin BrushPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end BrushPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

    void SpinRadius( wxSpinEvent &event);
    void UpdateRadius( wxCommandEvent &event);
    void OnEraseBrushChange( wxCommandEvent &event);
////@begin BrushPanel member variables
    wxSpinCtrl* mRadius;
    wxCheckBox* mBrushErase;
////@end BrushPanel member variables
};

#endif
    // _BRUSHPANEL_H_
