/*
  For more information, please see: http://software.sci.utah.edu
  
  The MIT License

  Copyright (c) 2009 Scientific Computing and Imaging Institute,
  University of Utah.


  Permission is hereby granted, free of charge, to any person obtaining a 
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation 
  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
  and/or sell copies of the Software, and to permit persons to whom the 
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included 
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
  DEALINGS IN THE SOFTWARE.
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        cursorinfo.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     21/08/2007 15:01:49
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 21/08/2007 15:01:49

#ifndef _CURSORINFO_H_
#define _CURSORINFO_H_

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/valtext.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CURSORINFORMATION 10026
#define SYMBOL_CURSORINFORMATION_STYLE 0
#define SYMBOL_CURSORINFORMATION_TITLE _("CursorInformation")
#define SYMBOL_CURSORINFORMATION_IDNAME ID_CURSORINFORMATION
#define SYMBOL_CURSORINFORMATION_SIZE wxDefaultSize
#define SYMBOL_CURSORINFORMATION_POSITION wxDefaultPosition
////@end control identifiers

struct CursorInformationStruct {
  double x, y, z;
  int xi, yi, zi;

  double value;
  double valuer;

  bool value_is_valid;
};


/*!
 * CursorInformation class declaration
 */

class CursorInformation: public wxPanel
{    
  DECLARE_DYNAMIC_CLASS( CursorInformation )
    DECLARE_EVENT_TABLE()

    public:
  /// Constructors
  CursorInformation();
  CursorInformation( wxWindow* parent, wxWindowID id = SYMBOL_CURSORINFORMATION_IDNAME, const wxPoint& pos = SYMBOL_CURSORINFORMATION_POSITION, const wxSize& size = SYMBOL_CURSORINFORMATION_SIZE, long style = SYMBOL_CURSORINFORMATION_STYLE );

  /// Creation
  bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CURSORINFORMATION_IDNAME, const wxPoint& pos = SYMBOL_CURSORINFORMATION_POSITION, const wxSize& size = SYMBOL_CURSORINFORMATION_SIZE, long style = SYMBOL_CURSORINFORMATION_STYLE );

  /// Destructor
  ~CursorInformation();

  /// Initialises member variables
  void Init();

  /// Creates the controls and sizers
  void CreateControls();

  void SetMousePositionAndValue(wxCommandEvent &event);
  void SetMousePosition(double x, double y, double z);
  void SetInfoValue(double value);
	
  ////@begin CursorInformation event handler declarations

  ////@end CursorInformation event handler declarations

  ////@begin CursorInformation member function declarations

  /// Retrieves bitmap resources
  wxBitmap GetBitmapResource( const wxString& name );

  /// Retrieves icon resources
  wxIcon GetIconResource( const wxString& name );
  ////@end CursorInformation member function declarations

  /// Should we show tooltips?
  static bool ShowToolTips();

  ////@begin CursorInformation member variables
  wxChoice* mColor_;
  wxChoice* mSpace_;

  wxTextCtrl* mValue_;
  wxTextCtrl* mPosX_;
  wxTextCtrl* mPosY_;
  wxTextCtrl* mPosZ_;
  ////@end CursorInformation member variables
	
};

#endif
// _CURSORINFO_H_
