//
//  For more information, please see: http://software.sci.utah.edu
//
//  The MIT License
//
//  Copyright (c) 2009 Scientific Computing and Imaging Institute,
//  University of Utah.
//
//
//  Permission is hereby granted, free of charge, to any person obtaining a
//  copy of this software and associated documentation files (the "Software"),
//  to deal in the Software without restriction, including without limitation
//  the rights to use, copy, modify, merge, publish, distribute, sublicense,
//  and/or sell copies of the Software, and to permit persons to whom the
//  Software is furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included
//  in all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
//  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
//  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
//  DEALINGS IN THE SOFTWARE.
//
//    File   : SceneGraphEvent.cc
//    Author : Martin Cole
//    Date   : Tue Jun  6 10:10:43 2006

#include <Core/Events/SceneGraphEvent.h>
#include <string>

namespace SCIRun {

using namespace std;

// Persistent *make_SceneGraphEvent() { return new SceneGraphEvent(); }
// PersistentTypeID SceneGraphEvent::type_id("SceneGraphEvent", "BaseEvent",
//                                           make_SceneGraphEvent);

SceneGraphEvent::SceneGraphEvent() :
  BaseEvent(),
  obj_(0),
  name_(),
  sg_id_(-1),
  toggle_visibility_(false),
  force_visibility_(false)
{
}


SceneGraphEvent::SceneGraphEvent(GeomHandle o, string n,
				 const string &target,
				 unsigned int time) :
  BaseEvent(target, time),
  obj_(o),
  name_(n),
  sg_id_(-1),
  toggle_visibility_(false),
  force_visibility_(false)
{
}


SceneGraphEvent::~SceneGraphEvent()
{
}

// void
// SceneGraphEvent::io(Piostream &stream) {
//   stream.begin_class(type_id.type, 1);
//   BaseEvent::io(stream);
//   SCIRun::Pio(stream, obj_);
//   SCIRun::Pio(stream, name_);
//   SCIRun::Pio(stream, sg_id_);
//   stream.end_class();
// }



} // namespace SCIRun

