//  
//  For more information, please see: http://software.sci.utah.edu
//  
//  The MIT License
//  
//  Copyright (c) 2009 Scientific Computing and Imaging Institute,
//  University of Utah.
//  
//  
//  Permission is hereby granted, free of charge, to any person obtaining a
//  copy of this software and associated documentation files (the "Software"),
//  to deal in the Software without restriction, including without limitation
//  the rights to use, copy, modify, merge, publish, distribute, sublicense,
//  and/or sell copies of the Software, and to permit persons to whom the
//  Software is furnished to do so, subject to the following conditions:
//  
//  The above copyright notice and this permission notice shall be included
//  in all copies or substantial portions of the Software.
//  
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
//  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
//  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
//  DEALINGS IN THE SOFTWARE.
//  
//    File   : ColorMap2DSemantics.cc
//    Author : Josh Stratton
//    Date   : Fri Jul 20 12:27:59 MDT 2007


#include <Dataflow/Network/Module.h>

#include <Core/Datatypes/Field.h>
#include <Dataflow/Network/Ports/SimplePort.h>
#include <Dataflow/Network/Ports/ColorMap2Port.h>
#include <iostream>

namespace SCIRun {
using namespace std;
using namespace SCIRun;

class ColorMap2DSemantics : public Module 
{
public:
  ColorMap2DSemantics(GuiContext*);
  virtual ~ColorMap2DSemantics() {}

  virtual void execute();
  virtual void tcl_command(GuiArgs&, void*);
};

DECLARE_MAKER(ColorMap2DSemantics)
ColorMap2DSemantics::ColorMap2DSemantics(GuiContext* ctx) : 
  Module("ColorMap2DSemantics", ctx, Source, "Visualization", "SCIRun")
{
}

void
ColorMap2DSemantics::execute()
{
  ColorMap2Handle icmap = 0;
  get_input_handle("Input Colormap", icmap, false);
  // Inform module that execution started
  update_state(Executing);

  send_output_handle("Output Colormap", icmap);
}

void
ColorMap2DSemantics::tcl_command(GuiArgs& args, void* userdata)
{
  Module::tcl_command(args, userdata);
}

} // End namespace SCIRun


